#include "include/define.h"
#include <jni.h>

int create_pel(int RR,int GG,int BB){
  RR=(RR<0?0:RR);
  RR=(RR>255?255:RR);
  GG=(GG<0?0:GG);
  GG=(GG>255?255:GG);
  BB=(BB<0?0:BB);
  BB=(BB>255?255:BB);
  return (0xFF000000 | (RR << 16) | (GG << 8) | (BB));
}

void yuv_to_rgb(jint *rgb_pels,pel_t ** (*yuv_frame)[3],struct dimensions_t dim){
  int m,n,i,rgb_vals[3];
  const float YUV_CONV[3][3]={{ 1.164,-0.002, 1.596},
			      { 1.164,-0.391,-0.813},
			      { 1.164, 2.018,-0.001}};
  const int YUV_OFF[3]={16,128,128};

  for(m=0;m<dim.height[_Y_];m++)
    for(n=0;n<dim.width[_Y_];n++){

      for(i=_R_;i<=_B_;i++)
	rgb_vals[i]=(int)(((*yuv_frame)[_Y_][m][n]-YUV_OFF[_Y_])*YUV_CONV[i][0]+
			  ((*yuv_frame)[_U_][m/2][n/2]-YUV_OFF[_U_])*YUV_CONV[i][1]+
			  ((*yuv_frame)[_V_][m/2][n/2]-YUV_OFF[_V_])*YUV_CONV[i][2]);
      
      rgb_pels[m*dim.width[_Y_]+n]=create_pel(rgb_vals[_R_],
					      rgb_vals[_G_],
					      rgb_vals[_B_]);

    }//for n
    
}


void rgb_to_yuv(){
  const float RGB_CONV[3][3]={{ 0.257, 0.504, 0.098},
			      {-0.148,-0.291, 0.439},
			      { 0.439,-0.368, 0.071}};
  const int YUV_OFF[3]={16,128,128};

}
