import java.awt.*;
import java.awt.image.*;
import java.lang.*;

class gui extends Frame{  

  public gui(){

    //Title Bar Caption
    setTitle(prog_name);

    //Menu Bar
    MenuBar mbar = new MenuBar();
    Menu m = new Menu("File");
    m.add(new MenuItem("Open QCIF YUV..."));
    m.add(new MenuItem("Open CIF YUV..."));
    m.add(new MenuItem("Open H261..."));
    m.addSeparator();
    m.add(new MenuItem("Quit"));
    mbar.add(m);

    m = new Menu("Control");
    m.add(new MenuItem("Play..."));
    m.add(new MenuItem("Step..."));
    m.addSeparator();
    m.add(new MenuItem("Encode..."));
    m.add(new MenuItem("Encode Step..."));
    m.addSeparator();
    //    m.add(new MenuItem("Stop"));
    m.add(new MenuItem("Reset"));
    mbar.add(m);

    m = new Menu("Help");
    m.add(new MenuItem("Help Topics"));
    m.addSeparator();
    m.add(new MenuItem("About " + prog_name));
    mbar.add(m);

    setMenuBar(mbar);

    //Info
    Panel p1 = new Panel();
    p1.setBackground(Color.black);
    p1.setForeground(Color.white);
    p1.setLayout(new GridLayout(3,1));
    p1.add(labelInfile = new Label("    File Name:           "));
    p1.add(labelFormat = new Label("    File Format:         "));
    p1.add(labelFramenum = new Label("    Current Frame:     "));
    add("North",p1);


    //Buttons
    Panel p2 = new Panel();
    p2.setLayout(new FlowLayout());
    p2.add(new Button("  Play  "));
    p2.add(new Button("  Step >>"));
    p2.add(new Button("  Encode  "));
    p2.add(new Button(" Encode Step >>"));
    //    p2.add(new Button("  Stop  "));
    p2.add(new Button("  Reset  "));
    add("South",p2);

    //Picture Canvas
    c = new DisplayH261();
    c.setBackground(Color.gray);
    add("Center",c);

    //init variables
    filename = "";
    filetype = NONE;
    started=false;
    playing=false;
    done=0;
    lastDirectory=".";

  }

  public void updateLabels(){

    String strFormat = "";
   
    switch (filetype){
    case NONE: strFormat="";break;
    case CIF_YUV: strFormat="CIF YUV";break;
    case QCIF_YUV: strFormat="QCIF YUV";break;
    case H261: strFormat="H261 Encoded";break;
    }

    labelInfile.setText("    File Name:           " + filename);
    labelFormat.setText("    File Format:         " + strFormat);
    if (playing==false){
      if (done==0)
        labelFramenum.setText("    Current Status:    STOPPED");
      else
        labelFramenum.setText("    Current Status:    STOPPED (DONE)");
    }
    else
      labelFramenum.setText("    Current Status:    PLAYING");
  }
  
  public void Menu_File_Open(int fileformat){

    FileDialog d = new FileDialog(this, "Open File",FileDialog.LOAD);
    //        d.setFilenameFilter("*.h261");
    d.setDirectory(lastDirectory);
    d.resize(330,330);
    d.show();
    String file = d.getFile();
    if (file != null){//!Cancel
      nat n=new nat();
      if (fileformat==H261 && 1==n.H261validate(d.getDirectory() + file)){
	ErrorDialog e = new ErrorDialog(this,"Invalid File Format!");
	e.show();
	return;
      }

      lastDirectory=d.getDirectory();
      filename=lastDirectory + file;
      filetype=fileformat;
      Menu_Control_Reset();

    }
  }

  public void Menu_Control_Play(int mode,boolean step){
    if (filetype!=NONE && done==0){

      if (started==false){
        switch (filetype){
        case QCIF_YUV:
	case CIF_YUV:
	  if (mode==MODE_YUV){
	    
            c.init(filename,"",0,0,0,filetype,mode);
	    started=true;
            frame_num=0;

	    playing=true;
	    updateLabels();
	    if (step==true)
	      done=c.stepDisplay();
	    else
	      done=c.runDisplay();
	    playing=false;
	    updateLabels();
	    
          }
          else{//mode==MODE_H261
            //get save file
            FileDialog d = new FileDialog(this,"Encode File",FileDialog.SAVE);
            //d.setFilenameFilter("*.h261");
            d.setDirectory(lastDirectory);
	    d.resize(330,330);
            d.show();
            String file = d.getFile();
            if (file != null){//!Cancel
              lastDirectory=d.getDirectory();
              outfilename=lastDirectory + file;

	        OptionsDialog opt = new OptionsDialog(this,
                MOTIONEST_HVMIN,0, 8);
  	        opt.show();
	        if (opt.CancelPressed==false){

		  
		  int t;
		  try{
		    t=Integer.valueOf(opt.thresh.getText().trim()).intValue();
		    if (t<0)
		      t=0;
		  }
		  catch(NumberFormatException e){
		    t=0;
		  }
		  
		  c.init(filename,outfilename,
			 opt.motionest.getSelectedIndex(),t,
			 2*(opt.quantsize.getSelectedIndex()+1),
			 filetype,mode);
	          started=true;
	          frame_num=0;                        
		  
		  playing=true;
		  updateLabels();
		  if (step==true)
		    done=c.stepDisplay();
		  else
		    done=c.runDisplay();
		  playing=false;
		  updateLabels();
		  
	        }//if
              opt.dispose();
            }  
	    }//else
          break;
        case H261:
          c.init(filename,"",0,0,0,filetype,mode);
          started=true;
          frame_num=0;

	  playing=true;
	  updateLabels();
	  if (step==true)
	    done=c.stepDisplay();
	  else
	    done=c.runDisplay();
	  playing=false;
	  updateLabels();

          break;
        }//switch
      }//if (started==false)
      else{

	playing=true;
	updateLabels();
	if (step==true)
	  done=c.stepDisplay();
	else
	  done=c.runDisplay();
	playing=false;
	updateLabels();

      }//else
    }//if (filetype!=NONE && done==0)  
  }

  public void Menu_Control_Stop(){

  }

  public void Menu_Control_Reset(){
    if (started==true && done!=1)
      c.resetDisplay();
    started=false;
    c.start=false;
    playing=false;
    done=0;
    updateLabels();
    Graphics g=c.getGraphics();
    g.fillRect(103,29,352,288);
    g.dispose();
  }

  public void Quit(){
    System.exit(0);
  }

  public boolean action(Event evt, Object arg){
    if (evt.target instanceof MenuItem){
      if (arg.equals("Open QCIF YUV...")) Menu_File_Open(QCIF_YUV);
      else if (arg.equals("Open CIF YUV...")) Menu_File_Open(CIF_YUV);
      else if (arg.equals("Open H261...")) Menu_File_Open(H261);

      else if (arg.equals("Play..."))
        Menu_Control_Play(MODE_YUV,false);
      else if (arg.equals("Step..."))
        Menu_Control_Play(MODE_YUV,true);
      else if (arg.equals("Encode..."))
        Menu_Control_Play(MODE_H261,false);
      else if (arg.equals("Encode Step..."))
        Menu_Control_Play(MODE_H261,true);

      else if (arg.equals("Stop")) Menu_Control_Stop();
      else if (arg.equals("Reset")) Menu_Control_Reset();

      else if (arg.equals("Help Topics")){
        HelpDialog h = new HelpDialog(this,prog_name);
        h.show();
      }
      else if (arg.equals("About " + prog_name)){
        AboutDialog ab = new AboutDialog(this,prog_name);
        ab.show();
      }
      else if (arg.equals("Quit")) Quit();
      else return super.action(evt,arg);
    }
    else if (evt.target instanceof Button){

      if (arg.equals("  Play  "))
        Menu_Control_Play(MODE_YUV,false);
      else if (arg.equals("  Step >>"))
        Menu_Control_Play(MODE_YUV,true);
      else if (arg.equals("  Encode  "))
        Menu_Control_Play(MODE_H261,false);
      else if (arg.equals(" Encode Step >>"))
        Menu_Control_Play(MODE_H261,true);

      else if (arg.equals("  Stop  ")) Menu_Control_Stop();
      else if (arg.equals("  Reset  ")) Menu_Control_Reset();
      else return super.action(evt,arg);
    }
    else return super.action(evt,arg);
    return true;
  }

  public boolean handleEvent(Event evt){
    if (evt.id == Event.WINDOW_DESTROY && evt.target == this) Quit();
    return super.handleEvent(evt);
  }

  public static void main(String[] args) {
    Frame f = new gui();
    f.setBackground(Color.lightGray);
    f.resize(575,500);
    f.show();
  }

  //constants
  static final String prog_name = "H261 Codekinator";
  static final int NONE            = 0;
  static final int QCIF_YUV        = 1;
  static final int CIF_YUV         = 2;
  static final int H261            = 3;
  static final int MOTIONEST_FULL  = 0;
  static final int MOTIONEST_HVMIN = 1;
  static final int MODE_YUV        = 0;
  static final int MODE_H261       = 1;
  
  //program variables
  private Image img;
  private Label labelInfile;
  private Label labelFormat;
  private Label labelFramenum;
  private DisplayH261 c;
  private boolean started;
  private boolean playing;
  private int done;
  private String lastDirectory;
  private String filename;
  private String outfilename;
  private int filetype;
  private int frame_num;
  private int mode;
}

class DisplayH261 extends Canvas{
  
  public void init(String ifname,String ofname,int type_motionest,
		   int threshold,int stepsize,int f,int m){

    infile = ifname;
    outfile = ofname;
    format = f;
    mode = m;
    options=new int[4];
    n=new nat();
    start=false;
    
    switch (format){
    case CIF_YUV:
      options[0]=CIF;
      width  = 352; 
      height = 288;
      break;
    case QCIF_YUV:
      options[0]=QCIF;
      width  = 176; 
      height = 144;
      break;
    case H261:
      switch(options[0]=n.H261getFormat(infile)){
      case CIF:
	width  = 352; 
	height = 288;
	break;
      case QCIF:
	width  = 176; 
	height = 144;
	break;
      }
      break;
    }
        
    pels=new int[width*height];
    options[1]=type_motionest;
    options[2]=threshold;
    options[3]=stepsize;

  }

  public void update(Graphics g){
    paint(g);
  }

  public void paint(Graphics g){
    if (start==false)
      g.fillRect(103,29,352,288);      
    else
      if (drawn==true)
	g.drawImage(img,OFFSET_X,OFFSET_Y,this);    
  }  

  public int runDisplay(){
    int done;
    while(0==(done=stepDisplay()));
    return done;
  }

  public int stepDisplay(){
 
    int done=0;
    Graphics g=getGraphics();
    start=true;

    switch(format){
    case QCIF_YUV:case CIF_YUV:
      switch(mode){
      case MODE_YUV:
	done=n.YUVplay(infile,pels,options,CONTINUE);
	break;
      case MODE_H261:
	done=n.H261encode(infile,outfile,pels,options,CONTINUE);
	break;
      }
      break;
    case H261:
      done=n.H261decode(infile,pels,CONTINUE);
      break;   
    }

    img = createImage(new MemoryImageSource(width,height,pels,0,width));
    drawn=true;
    g.drawImage(img,OFFSET_X,OFFSET_Y,this);      
    //try{sleep(5);}catch(InterruptedException e){}
    g.dispose();

    return done;

  }
 
  public void resetDisplay(){
    switch(format){
    case QCIF_YUV:case CIF_YUV:
      switch(mode){
      case MODE_YUV:
	n.YUVplay(infile,pels,options,KILL);
	break;
      case MODE_H261:
        n.H261encode(infile,outfile,pels,options,KILL);
	break;
      }
      break;
    case H261:
      n.H261decode(infile,pels,KILL);
      break;   
    }
  }  

  //constants
  static final int NONE            = 0;
  static final int QCIF_YUV        = 1;
  static final int CIF_YUV         = 2;
  static final int H261            = 3;
  static final int QCIF            = 0;
  static final int CIF             = 1;
  static final int MOTIONEST_FULL  = 0;
  static final int MOTIONEST_HVMIN = 1;
  static final int QUANT_BASIC     = 0;
  static final int QUANT_THRESH    = 1;
  static final int MODE_YUV        = 0;
  static final int MODE_H261       = 1;

  static final int OFFSET_X        = 103;
  static final int OFFSET_Y        = 29;

  static final int[] CONTINUE      = {0};
  static final int[] KILL          = {1};


  //program variables
  private nat n;
  private boolean drawn=false;
  public boolean start=false;
  private Image img;
  private static int[] pels;
  private static int[] options;
  private int width;
  private int height;
  private int mode;
  private int format;
  private String infile;
  private String outfile;
}

class AboutDialog extends Dialog{

  public AboutDialog(Frame parent,String prog_name){
    //Specify caption title and Modal=true
    super(parent,"About " + prog_name,true);

    Panel p1 = new Panel();
    p1.add(new Label(prog_name));
    p1.add(new Label("By Ben Ernest-Jones and Markus Adhiwiyogo"));
    p1.add(new Label("18-796: Multimedia - Coding and Networking"));
    p1.add(new Label("Spring 1999"));
    add("Center",p1);

    Panel p2 = new Panel();
    p2.add(new Button("OK"));
    add("South",p2);
    resize(330,200);
    
  }

  public boolean action(Event evt,Object arg){
    if(arg.equals("OK")){
      dispose();
      return true;
    }
    return false;
  }

  public boolean handleEvent(Event evt){
    if (evt.id == Event.WINDOW_DESTROY && evt.target == this) System.exit(0);
    return super.handleEvent(evt);
  }

}

class HelpDialog extends Dialog{

  public HelpDialog(Frame parent,String prog_name){
    //Specify caption title and Modal=true
    super(parent,"Help on " + prog_name,true);

    Panel p1 = new Panel();
    p1.add(new Label(prog_name));
    p1.add(new Label("Use your intuition."));
    add("Center",p1);

    Panel p2 = new Panel();
    p2.add(new Button("OK"));
    add("South",p2);
    resize(220,150);
    
  }

  public boolean action(Event evt,Object arg){
    if(arg.equals("OK")){
      dispose();
      return true;
    }
    return false;
  }

  public boolean handleEvent(Event evt){
    if (evt.id == Event.WINDOW_DESTROY && evt.target == this) System.exit(0);
    return super.handleEvent(evt);
  }

}

class ErrorDialog extends Dialog{

  public ErrorDialog(Frame parent,String msg){
    //Specify caption title and Modal=true
    super(parent,"Error Message",true);

    Panel p1 = new Panel();
    p1.add(new Label(msg));
    add("Center",p1);

    Panel p2 = new Panel();
    p2.add(new Button("OK"));
    add("South",p2);
    resize(220,150);
    
  }

  public boolean action(Event evt,Object arg){
    if(arg.equals("OK")){
      dispose();
      return true;
    }
    return false;
  }

  public boolean handleEvent(Event evt){
    if (evt.id == Event.WINDOW_DESTROY && evt.target == this) System.exit(0);
    return super.handleEvent(evt);
  }

}

class OptionsDialog extends Dialog{

  public OptionsDialog(Frame parent,int type_motionest,int threshold,int stepsize){
    //Specify caption title and Modal=true
    super(parent,"Encoding Options",true);

    Panel p1 = new Panel();
    p1.setLayout(new GridLayout(3,1));

    Panel p2 = new Panel();
    p2.setLayout(new FlowLayout());
    motionest = new Choice();
    motionest.addItem("Optimal (Slow)");
    motionest.addItem("Sub-Optimal (Fast)");
    motionest.select(type_motionest);
    p2.add(new Label("  Motion Estimation: "));
    p2.add(motionest);
    p1.add(p2);

    p2 = new Panel();
    p2.setLayout(new FlowLayout());
    quantsize = new Choice();
    int i;
    for(i=1;i<=31;i++)
      quantsize.addItem(Integer.toString(i*2));
    quantsize.select(stepsize/2-1);
    p2.add(new Label("  Quantization Stepsize: "));
    p2.add(quantsize);
    p1.add(p2);

    p2 = new Panel();
    p2.setLayout(new FlowLayout());
    thresh = new TextField(5);
    thresh.setText(Integer.toString(threshold));
    p2.add(new Label("  Quantization Threshold: "));
    p2.add(thresh);
    p1.add(p2);

    add("Center",p1);

    p2 = new Panel();
    p2.add(new Button("OK"));
    p2.add(new Button("Cancel"));
    add("South",p2);
    resize(330,200);
    
  }

  public boolean action(Event evt,Object arg){
    if(arg.equals("OK")){
      show(false);
      CancelPressed=false;
      return true;
    }
    else if(arg.equals("Cancel")){
      show(false);
      CancelPressed=true;
      return true;
    }
    return false;
  }

  public boolean handleEvent(Event evt){
    if (evt.id == Event.WINDOW_DESTROY && evt.target == this)       System.exit(0);
    return super.handleEvent(evt);
  }

  public Choice motionest;
  public TextField thresh;
  public Choice quantsize;
 
  public boolean CancelPressed;

}

