//*******************************************
// Ben Ernest-Jones
// 18-796
//
// Huffman Tree Builder
//
//*******************************************

#include "include/define.h"
#include <iostream.h>

char vlc_val(int which,int ind1,int ind2){
  switch (which){
  case MBA_CODE:
    return MBA[ind1][ind2];
  case MTYPE_CODE:
    return MTYPE[ind1][ind2];
  case MVD_CODE:
    return MVD[ind1][ind2];
  case CBP_CODE:
    return CBP[ind1][ind2];
  }
}

char vlc_val(int which,int ind1,int ind2,int ind3){
  switch (which){
  case TCOEFF_CODE:
    return TCOEFF[ind1][ind2][ind3];
  }
}

nodep BuildHuffmanTree(int which,int len){
  //builds a huffman tree in memory from "arr", a 1D array of
  //"len" strings
  
  struct node *head,*currentNode;
  int i,c;

  head=new node;

  for(i=0;i<len;i++){
    currentNode=head;
    for(c=0;vlc_val(which,i,c)!=0;c++)
      if(vlc_val(which,i,c)=='1'){
	if(currentNode->left==NULL)
	  currentNode->left=new node;
	currentNode=currentNode->left;
      }
      else{
	if(currentNode->right==NULL)
	  currentNode->right=new node;
	currentNode=currentNode->right;
      }
    currentNode->info[0]=i;
  }//for i
  
  return head;

}

nodep BuildHuffmanTree(int which,int len1,int len2){
  //builds a huffman tree in memory from "arr", a 2D array of
  //"len1" x "len2" strings
  
  struct node *head,*currentNode;
  int i,j,c;

  head=new node;

  for(i=0;i<len1;i++)
    for(j=0;j<len2;j++){
      if (vlc_val(which,i,j,0)!=0){
        currentNode=head;
        for(c=0;vlc_val(which,i,j,c)!=0;c++)
          if(vlc_val(which,i,j,c)=='1'){
	    if(currentNode->left==NULL)
	      currentNode->left=new node;
            currentNode=currentNode->left;
          }
          else{
	    if(currentNode->right==NULL)
	      currentNode->right=new node;
            currentNode=currentNode->right;
          }        
        if (i!=27){
          currentNode->info[0]=i;
          currentNode->info[1]=j;
        }
        else
          currentNode->info[0]=28-j;
        
      }//if str is present
    }//for j

  return head;

}


void KillHuffmanTree(nodep head){
  //deletes all nodes of a huffman tree

}
