#include <math.h>
#include "include/define.h"

void MotionComp(pel_t **res[3],int **mot_vectors[2],pel_t **frame[2][3],
		int prev,int height[3],int width[3]) {

  //Subtract motion vectors into the residues  
  int m,n,dx,dy;
  
  for(m = 0; m < height[_Y_]; m++) //Step through MB
    for(n = 0; n < width[_Y_]; n++){    
      dx = mot_vectors[_DX_][m/_MB_SIZE_][n/_MB_SIZE_]; //MVs
      dy = mot_vectors[_DY_][m/_MB_SIZE_][n/_MB_SIZE_];
      res[_Y_][m][n] = frame[1-prev][_Y_][m][n] - 
	frame[prev][_Y_][m+dy][n+dx];
    }
  
  for(m = 0; m < height[_U_]; m++) //Step through MB
    for(n = 0; n < width[_U_]; n++){    
      dx = mot_vectors[_DX_][m/_BLOCK_SIZE_][n/_BLOCK_SIZE_]/2; //MVs
      dy = mot_vectors[_DY_][m/_BLOCK_SIZE_][n/_BLOCK_SIZE_]/2;
      res[_U_][m][n] = frame[1-prev][_U_][m][n] - 
	frame[prev][_U_][m+dy][n+dx];
      res[_V_][m][n] = frame[1-prev][_V_][m][n] - 
	frame[prev][_V_][m+dy][n+dx];
    }
  
}
