/********************************
 Ben Ernest-Jones
 18-796
 HW 4
 2/17/99

 motion compensation operations

 ********************************/

#define DEBUG


#include <math.h>
#include "include/define.h"

#ifdef DEBUG
#include <iostream.h>
#endif

inline void getMinMAD(pel_t **frame[2][3],int prev,int height[3],
		      int width[3],int size,int x,int y,
		      int dx,int dy,
		      long &minMAD,int &minX,int &minY){

  long MAD;
  int breakout,i,j;

  if (x*size+dx>=0 && x*size+dx+size-1<width[_Y_] &&
      y*size+dy>=0 && y*size+dy+size-1<height[_Y_]){
    //make sure we stay within bounds of frame
    
    /*loop through pels*/
    breakout=0;
    MAD=0;
    for(i=0;i<size && breakout==0;i++){

      /*second loop is unrolled for optimization:*/

      MAD+=abs((long)frame[1-prev][_Y_][y*size+i][x*size+0]-
	       (long)frame[prev][_Y_][y*size+dy+i][x*size+dx+0]);
      /* break out of loop if MAD exceeds current minimum MAD */
      if (minMAD!=-1 && MAD>minMAD) 
	breakout=1;
      else{
	MAD+=abs((long)frame[1-prev][_Y_][y*+i][x*size+1]-
		 (long)frame[prev][_Y_][y*size+dy+i][x*size+dx+1]);
	MAD+=abs((long)frame[1-prev][_Y_][y*size+i][x*size+2]-
		 (long)frame[prev][_Y_][y*size+dy+i][x*size+dx+2]);
	MAD+=abs((long)frame[1-prev][_Y_][y*size+i][x*size+3]-
		 (long)frame[prev][_Y_][y*size+dy+i][x*size+dx+3]);
	MAD+=abs((long)frame[1-prev][_Y_][y*size+i][x*size+4]-
		 (long)frame[prev][_Y_][y*size+dy+i][x*size+dx+4]);
	MAD+=abs((long)frame[1-prev][_Y_][y*size+i][x*size+5]-
		 (long)frame[prev][_Y_][y*size+dy+i][x*size+dx+5]);
	MAD+=abs((long)frame[1-prev][_Y_][y*size+i][x*size+6]-
		 (long)frame[prev][_Y_][y*size+dy+i][x*size+dx+6]);
	MAD+=abs((long)frame[1-prev][_Y_][y*size+i][x*size+7]-
		 (long)frame[prev][_Y_][y*size+dy+i][x*size+dx+7]);
	
	/* break out of loop if MAD exceeds current minimum MAD */
	if (minMAD!=-1 && MAD>minMAD) 
	  breakout=1;
	else{
	  
	  MAD+=abs((long)frame[1-prev][_Y_][y*size+i][x*size+8]-
		   (long)frame[prev][_Y_][y*size+dy+i][x*size+dx+8]);
	  MAD+=abs((long)frame[1-prev][_Y_][y*size+i][x*size+9]-
		   (long)frame[prev][_Y_][y*size+dy+i][x*size+dx+9]);
	  MAD+=abs((long)frame[1-prev][_Y_][y*size+i][x*size+10]-
		   (long)frame[prev][_Y_][y*size+dy+i][x*size+dx+10]);
	  MAD+=abs((long)frame[1-prev][_Y_][y*size+i][x*size+11]-
		   (long)frame[prev][_Y_][y*size+dy+i][x*size+dx+11]);
	  MAD+=abs((long)frame[1-prev][_Y_][y*size+i][x*size+12]-
		   (long)frame[prev][_Y_][y*size+dy+i][x*size+dx+12]);
	  MAD+=abs((long)frame[1-prev][_Y_][y*size+i][x*size+13]-
		   (long)frame[prev][_Y_][y*size+dy+i][x*size+dx+13]);
	  MAD+=abs((long)frame[1-prev][_Y_][y*size+i][x*size+14]-
		   (long)frame[prev][_Y_][y*size+dy+i][x*size+dx+14]);
	  MAD+=abs((long)frame[1-prev][_Y_][y*size+i][x*size+15]-
		   (long)frame[prev][_Y_][y*size+dy+i][x*size+dx+15]);
	  
	  if (minMAD!=-1 && MAD>minMAD) 
	    breakout=1;
	  
	}//else
      }//else
      
    }//i
    
    if (-1==minMAD || MAD<minMAD){
      minMAD=MAD;
      minX=dx;
      minY=dy;
    }
    else if (MAD==minMAD){
      //pick motion vector with smallest magnitude
      minX=(sqrt(dx*dx+dy*dy)<sqrt(minX*minX+minY*minY)?
	    dx:minX);
      minY=(sqrt(dx*dx+dy*dy)<sqrt(minX*minX+minY*minY)?
	    dy:minY);
    }
    
  }//if motion vector within frame
  
}

void MotionEst_HVMin(int **mot_vectors[2],pel_t **frame[2][3],
                     int prev,int height[3],int width[3],int size) {

  long MinMAD;
  int minX,minY,x,y,dx,dy;

  //MAD calculations (partitioned into 16 by 16 blocks
  for(x=0;x<width[_Y_]/size;x++)
    for(y=0;y<height[_Y_]/size;y++){

      MinMAD=-1;       
      
      //***********************************
      //First we will do Horizontal Minimum
      //***********************************

      //current MAD
      getMinMAD(frame,prev,height,width,size,x,y,0,0,
		MinMAD,minX,minY);

      //left MAD
      getMinMAD(frame,prev,height,width,size,x,y,-1,0,
		MinMAD,minX,minY);
      
      //right MAD
      getMinMAD(frame,prev,height,width,size,x,y,1,0,
		MinMAD,minX,minY);
      
      //Now we will see which direction we will go
      if(minX==-1) //Go left
	for(dx=-2;dx>=-15;dx--)
	  getMinMAD(frame,prev,height,width,size,x,y,dx,0,
		    MinMAD,minX,minY);
      
      if(minX==1) //Go Right
	for(dx=2;dx<=15;dx++)
	  getMinMAD(frame,prev,height,width,size,x,y,dx,0,
		    MinMAD,minX,minY);
      
      //***********************************
      //Now we will find Vertical Minimum
      //***********************************

      //down MAD
      getMinMAD(frame,prev,height,width,size,x,y,minX,1,
		MinMAD,minX,minY);

      //up MAD
      getMinMAD(frame,prev,height,width,size,x,y,minX,-1,
		MinMAD,minX,minY);

      //Now we will see which direction we will go
      if(minY==1) //Go Down
	for(dy=2;dy<=15;dy++)
	  getMinMAD(frame,prev,height,width,size,x,y,minX,dy,
		    MinMAD,minX,minY);

      if(minY==-1) //Go Up
	for(dy=-2;dy>=-15;dy--)
	  getMinMAD(frame,prev,height,width,size,x,y,minX,dy,
		    MinMAD,minX,minY);

      //save motion vector to array
      mot_vectors[_DX_][y][x]=minX;
      mot_vectors[_DY_][y][x]=minY;
      
    }
}


void MotionEst_Full(int **mot_vectors[2],pel_t **frame[2][3],
		    int prev,int height[3],int width[3],int size){
  // Calculate motion estimation vectors for a YUV image.
  //   -'frame' contains the current and previous frames
  //   -'res' contains the residues for the previous frame
  //   -the result is stored in 'mot_vectors'
  //
  //   This implementation of Motion Estimation uses a comprehensive
  //   optimal search strategy. All motion vectors are checked for the
  //   minimum MAD value.  Motion Vectors are checked starting from [0,0].
  //   then spiraling out to the max and min ranges.

  long minMAD;
  int x,y,dx,dy,a,minX,minY;

  //loop through macroblocks
  for(x=0;x<width[_Y_]/size;x++){

#ifdef DEBUG
    cout<<x<<' '<<flush;
#endif
	
    for(y=0;y<height[_Y_]/size;y++){

      minMAD=-1;
      //loop through surrounding motion vectors
      for(a=0;a<=MOT_EST_HI_RANGE;a++)
	for(dy=-1*a;dy<=a;dy++){
	  for(dx=-1*a;dx<=a;dx=((abs(dy)==a||dx==a)?dx+1:a)){

	    getMinMAD(frame,prev,height,width,size,x,y,dx,dy,
		      minMAD,minX,minY);
	    
	  }//dy
	}//dx

      //save motion vector to array
      mot_vectors[_DX_][y][x]=minX;
      mot_vectors[_DY_][y][x]=minY;

    }//y
  }//x

#ifdef DEBUG
  cout<<endl<<flush;
#endif

}//MoionEst_Full


