#include "include/define.h"

#include <iostream.h>

void Quantize(pel_t **Q[],pel_t **A[],int stepsize,int format,int comp,
	      int gquant[],int *mquant[],int mode,int threshold){
  /* quantize values of A according to stepsize, and return results in Q */
  /* Also, loop size depends on which matrix we are quantizing */

  int i,j,m,n,bsize,h,w;
  int adaptive;
  pel_t temp;

  //loop through GOB
  for(i=0;i<(format==_CIF_?6:3);i++)
    for(j=0;j<(format==_CIF_?2:1);j++){
      gquant[i*2+j]=stepsize/2;
      //loop through MB
      for(m=0;m<3;m++)
	for(n=0;n<11;n++){
	  mquant[i*2+j][m*11+n]=-1;
	  adaptive=threshold;
	  //loop through pels
	  bsize=(comp==_Y_?_MB_SIZE_:_BLOCK_SIZE_);
	  for (h=0;h<bsize;h++)
	    for (w=0;w<bsize;w++)
	      if (mode==INTRA && h==0 && w==0)
		(*Q)[(i*3+m)*bsize+h][(j*11+n)*bsize+w]=(int)
		  ((((double)(*A)[(i*3+m)*bsize+h][(j*11+n)*bsize+w])/
		    (double)INTRA_DC_QSTEPSIZE)+0.5);
	      else{
		/*
		(*Q)[(i*3+m)*bsize+h][(j*11+n)*bsize+w]=(int)
		  ((((double)(*A)[(i*3+m)*bsize+h][(j*11+n)*bsize+w])/
		    (double)stepsize));
		*/

		if(abs((long)(*A)[(i*3+m)*bsize+h][(j*11+n)*bsize+w]) 
		   >= adaptive){
		  (*Q)[(i*3+m)*bsize+h][(j*11+n)*bsize+w]=(int)
		    ((((double)(*A)[(i*3+m)*bsize+h][(j*11+n)*bsize+w])/
		      (double)stepsize));
		  adaptive = threshold;
		}
		else{
		  (*Q)[(i*3+m)*bsize+h][(j*11+n)*bsize+w] = 0;
		  adaptive++;
		}
	      }
	}
    }
  
}

int reconstruct(pel_t level,int quant){
  if (level==0)
    return 0;
  if (level>0 && quant%2!=0)
    return (int)clip(quant*(2*level+1),-2048,2047);
  if (level<0 && quant%2!=0)
    return (int)clip(quant*(2*level-1),-2048,2047);
  if (level>0 && quant%2==0)
    return (int)clip(quant*(2*level+1)-1,-2048,2047);
  if (level<0 && quant%2==0)
    return (int)clip(quant*(2*level-1)+1,-2048,2047);
}

void DeQuantize(pel_t **A[],pel_t **Q[],int format,int comp,int gquant[],
		int *mquant[],int mode){
  /* dequantize values of Q according to stepsize, and return results in A */
  /* Also, loop size depends on which matrix we are quantizing */

  int i,j,m,n,h,w,stepsize,bsize;

  //loop through GOB
  for(i=0;i<(format==_CIF_?6:3);i++)
    for(j=0;j<(format==_CIF_?2:1);j++){
      stepsize=gquant[i*2+j];
      //loop through MB
      for(m=0;m<3;m++)
	for(n=0;n<11;n++){
	  if (mquant[i*2+j][m*11+n]!=-1)
	    stepsize=mquant[i*2+j][m*11+n];
	  //loop through pels
	  bsize=(comp==_Y_?_MB_SIZE_:_BLOCK_SIZE_);
	  for (h=0;h<bsize;h++)
	    for (w=0;w<bsize;w++)
	      if (mode==INTRA && h==0 && w==0)
	      (*A)[(i*3+m)*bsize+h][(j*11+n)*bsize+w]=(int)
		((*Q)[(i*3+m)*bsize][(j*11+n)*bsize]*INTRA_DC_QSTEPSIZE);
	      else
	      (*A)[(i*3+m)*bsize+h][(j*11+n)*bsize+w]=
		reconstruct((*Q)[(i*3+m)*bsize+h][(j*11+n)*bsize+w],stepsize);
	}
    }

}

